<script lang="ts">
  import { goto } from '$app/navigation';
  import Countdown from '@components/Countdown.svelte';
  import { EventCfgByIdQuery } from '@models/EventConfigurations';
  import type { EventConfiguration } from '@models/EventConfigurations';
  import { onMount } from 'svelte';
  import { Gql } from '@db';
  import { eventId } from '@stores';
  let eventCfg: EventConfiguration | null = null;
  let ready: Promise<void>;

  onMount(() => {
    ready = new Promise((resolve) => {
      const EventSink = {
        complete: () => console.warn('Event Sink Completed'),
        error: (err: unknown) => console.error(err),
        next: (value: { data: { events_by_pk: EventConfiguration } }) => {
          eventCfg = value.data.events_by_pk;
          resolve();
        },
      };

      Gql.subscribe(`subscription ${EventCfgByIdQuery($eventId)}`, EventSink);
    });
  });
</script>

<svelte:head>
  <title>Countdown</title>
</svelte:head>

<div class="container pt-4">
  {#await ready}
    <p>loading...</p>
  {:then ev}
    {#key eventCfg}
      <Countdown on:eventStarted={() => goto('/scoreboard')} {eventCfg} displayText size={60} />
    {/key}
  {/await}
</div>
